﻿using System;
using System.Threading.Tasks;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Net;

namespace metastrings
{
    public class api : IDisposable
    {
        public api(string serverUrl)
        {
            m_ops = new ops(serverUrl);
        }

        public void Dispose()
        {
            // Nothing Yet.  Great band!
        }

        public async Task DefineAsync(Define define)
        {
            await m_ops.DoApiAsyncVoid(define, "define").ConfigureAwait(false);
        }

        public async Task DefineCsvAsync(string csv)
        {
            await m_ops.DoWebAsync(csv, "definecsv").ConfigureAwait(false);
        }

        public async Task<GetResponse> GetAsync(GetRequest getRequest)
        {
            GetResponse response = await m_ops.DoApiAsync<GetRequest, GetResponse>(getRequest, "get").ConfigureAwait(false);
            return response;
        }

        public async Task<GetResponse> QueryGetAsync(QueryGetRequest getRequest)
        {
            GetResponse response = await m_ops.DoApiAsync<QueryGetRequest, GetResponse>(getRequest, "queryGet").ConfigureAwait(false);
            return response;
        }

        public async Task<string> GetSqlAsync(Select select)
        {
            string responseStr = await m_ops.DoWebAsync(Utils.Serialize(select), "sql").ConfigureAwait(false);
            return responseStr;
        }

        public async Task DeleteAsync(Delete deletes)
        {
            await m_ops.DoApiAsyncVoid(deletes, "delete").ConfigureAwait(false);
        }

        public async Task DropAsync(Drop drop)
        {
            await m_ops.DoApiAsyncVoid(drop, "drop").ConfigureAwait(false);
        }

        public async Task ResetAsync(Reset reset)
        {
            await m_ops.DoApiAsyncVoid(reset, "reset").ConfigureAwait(false);
        }

        public async Task<string> GetTimingSummary(Timing timing)
        {
            string responseStr = await m_ops.DoWebAsync(Utils.Serialize(timing), "timing").ConfigureAwait(false);
            return responseStr;
        }

        private ops m_ops;
    }
}
