﻿using System;
using System.Threading.Tasks;
using System.Text;
using System.IO;
using System.Net;

namespace metastrings
{
    class ops
    {
        public ops(string serverUrl)
        {
            m_serverUrl = serverUrl;
        }

        public async Task<ResponseType> DoApiAsync<RequestType, ResponseType>(RequestType request, string type)
        {
            string responseStr = await DoWebAsync(Utils.Serialize(request), type).ConfigureAwait(false);
            var responseObj = Utils.Deserialize<ResponseType>(responseStr);
            return responseObj;
        }

        public async Task DoApiAsyncVoid<RequestType>(RequestType request, string type)
        {
            await DoWebAsync(Utils.Serialize(request), type).ConfigureAwait(false);
        }

        public async Task<string> DoWebAsync(string str, string type)
        {
            try
            {
                var req = WebRequest.CreateHttp($"{m_serverUrl}?type={type}");
                req.Method = "POST";

                using (var requestStream = await req.GetRequestStreamAsync().ConfigureAwait(false))
                using (var sw = new StreamWriter(requestStream, Encoding.UTF8))
                    await sw.WriteAsync(str).ConfigureAwait(false);

                string responseString;
                using (var response = await req.GetResponseAsync().ConfigureAwait(false))
                using (var responseStream = response.GetResponseStream())
                using (var sr = new StreamReader(responseStream, Encoding.UTF8))
                    responseString = await sr.ReadToEndAsync().ConfigureAwait(false);

                return responseString;
            }
            catch (Exception exp)
            {
                throw Utils.HandleException(exp);
            }
        }

        private string m_serverUrl;
    }
}
