﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace metastrings
{
    public static class CsvPrep
    {
        public static string NullCellValue = "== null ==";

        public static string CleanseCsv(string str)
        {
            if (str == null)
                return NullCellValue;

            if (str.IndexOf(',') < 0 && str.IndexOf('\"') < 0) // clean, no op
                return str;

            return $"\"{str.Replace("\"", "\"\"")}\"";
        }

        public static string CleanseCsvObj(object obj)
        {
            if (obj == null)
                return NullCellValue;

            return CleanseCsv(obj.ToString());
        }

        public static string UnNullCsv(string str)
        {
            return str == NullCellValue ? null : str;
        }

        public static string CreateCsv(IEnumerable<string> strs)
        {
            return string.Join(",", strs.Select(s => CleanseCsv(s)));
        }

        public static string CreateCsv(IEnumerable<object> objs)
        {
            return string.Join(",", objs.Select(o => CleanseCsvObj(o)));
        }
    }
}
