﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;

namespace metastrings
{
    public struct MyFileInfo
    {
        public string FilePath;
        public ListDictionary<string, object> Metadata;

        public MyFileInfo(string filePath)
        {
            FilePath = filePath;
            Metadata = new ListDictionary<string, object>();
        }

        public void AddMetadata(string name, object value)
        {
            if (value == null)
                Metadata[name] = "";
            else if (value is DateTime)
                Metadata[name] = ((DateTime)value).ToString("yyyy/MM/dd HH:mm:ss");
            else
                Metadata[name] = value;
        }
    }
}
