﻿using System;
using System.Text;

using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace metastrings
{
    [TestClass]
    public class DefineCsvTest
    {
        [TestMethod]
        public void TestDefineCsv()
        {
            using (var ctxt = new Context())
            {
                Items.Reset(ctxt);

                StringBuilder sb = new StringBuilder();
                sb.AppendLine("type");
                sb.AppendLine("fun2");
                sb.AppendLine("key2,num2#,str2");
                sb.AppendLine("some2,422,foobar2");
                string csv = sb.ToString();

                using (Command cmd = new Command(ctxt))
                    cmd.DefineCsvAsync(csv).Wait();

                long itemId = Items.GetIdAsync(ctxt, Types.GetIdAsync(ctxt, "fun2").Result, Values.GetIdAsync(ctxt, "some2").Result).Result;
                var itemData = NameValues.GetMetadataValuesAsync(ctxt, Items.GetItemDataAsync(ctxt, itemId).Result).Result;

                Assert.AreEqual(422.0, itemData["num2"]);
                Assert.AreEqual("foobar2", itemData["str2"]);
            }
        }
    }
}
