﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace metastrings
{
    [TestClass]
    public class NameTests
    {
        [TestMethod]
        public void TestNames()
        {
            for (int t = 1; t <= 2; ++t)
            {
                using (var ctxt = new Context())
                {
                    NameValues.Reset(ctxt);

                    short typeId = Types.GetIdAsync(ctxt, "sometype").Result;

                    short firstId = Names.GetIdAsync(ctxt, typeId, "foobar").Result;
                    short secondId = Names.GetIdAsync(ctxt, typeId, "foobar").Result;
                    Assert.AreEqual(firstId, secondId);

                    NameObj name = Names.GetNameAsync(ctxt, secondId).Result;
                    Assert.AreEqual("foobar", name.name);
                    Assert.AreEqual("foobar", Names.GetNameAsync(ctxt, secondId).Result.name);

                    NameValues.Reset(ctxt);
                }
            }
        }
    }
}
