﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace metastrings
{
    [TestClass]
    public class TypeTests
    {
        [TestMethod]
        public void TestTypes()
        {
            for (int t = 1; t <= 2; ++t)
            {
                using (var ctxt = new Context())
                {
                    NameValues.Reset(ctxt);

                    short firstId = Types.GetIdAsync(ctxt, "foobar", isNumeric: true).Result;
                    short secondId = Types.GetIdAsync(ctxt, "foobar").Result;
                    Assert.AreEqual(firstId, secondId);

                    TypeObj type = Types.GetTypeAsync(ctxt, secondId).Result;
                    Assert.AreEqual("foobar", type.name);
                    Assert.IsTrue(type.isNumeric);

                    TypeObj type2 = Types.GetTypeAsync(ctxt, secondId).Result;
                    Assert.AreEqual("foobar", type2.name);
                    Assert.IsTrue(type2.isNumeric);

                    NameValues.Reset(ctxt);
                }
            }
        }
    }
}
