﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace metastrings
{
    [TestClass]
    public class ValueTests
    {
        [TestMethod]
        public void TestValues()
        {
            using (var ctxt = new Context())
            {
                NameValues.Reset(ctxt);

                var testLens = new[] { 10, Values.PrefixLen - 1, Values.PrefixLen, Values.PrefixLen + 1, Values.PrefixLen * 2 };
                foreach (var testLen in testLens)
                {
                    string testStr = "";
                    for (int t = 1; t <= testLen; ++t)
                        testStr += (t % 10).ToString();

                    long firstId = Values.GetIdAsync(ctxt, testStr).Result;
                    long secondId = Values.GetIdAsync(ctxt, testStr).Result;
                    Assert.AreEqual(firstId, secondId);

                    NameValues.Reset(ctxt);
                }
            }
        }
    }
}

